#include "xwc.h"
#include "funcs.h"
#include "especies.h"
#include <unistd.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

#define TAM_JANELA 600

void GeraHex(int x, char *dest);

int GeraCor(int r, int g, int b);

void GeraPaleta (int[32], int r, int g, int b);

void GeraTabCor(int tabcor[NUM_ESP][32]);

void iniciagraf ();

void fechagraf ();

void desenha (favo M[N][N]);

void PlotaTabCor ();

void desenhaplacar (int);

void GetNamae(int num, namae nome);

void ArrumaRanking (int pos[NUM_ESP+1]);

void ShowCredits(favo M[N][N]);

void piccredito (PIC pic, PIC fundo);

void rankcredito(int invrank[NUM_ESP+1]);

void rankfrase(int pos, namae na);

extern int popespecies[NUM_ESP+1];

extern int iteracoes;

static int cor[12][32];

static int rank[NUM_ESP+1];

int histmorte[NUM_ESP+1];

static WINDOW *w;

static  PIC pic;
static  PIC pla;

static WINDOW *placar;
static WINDOW *fin;
static int Preto;

void iniciagraf ()
{
  int k;
  for(k=1;k<=NUM_ESP;k++) rank[k]=1;
  w = InitGraph(TAM_JANELA, TAM_JANELA, "BIRA FIGHT!!!");
  placar = InitGraph(150, TAM_JANELA + 100, "BIRA PLACAR!!");
  pic = NewPic(w,TAM_JANELA, TAM_JANELA);
  pla = NewPic(placar, 150, 700);
  Preto = WNamedColor("black");
  WFillRect(w,   0, 0, TAM_JANELA, TAM_JANELA, Preto);
  WFillRect(pic, 0, 0, TAM_JANELA, TAM_JANELA, Preto);
  WFillRect(pla, 0, 0, 150, 700, Preto);
  GeraTabCor (cor);
  sleep(1);
}


void fechagraf ()
{
  FreePic(pla);
  FreePic(pic);
  CloseGraph ();
}

void GeraHex(int x, char *dest)
{
  int a, b;
  x %= 256;
  b = x % 16;
  x >>= 4;
  a = x % 16;
  b = b < 10 ? b + '0' : b-10 + 'A';
  a = a < 10 ? a + '0' : a-10 + 'A';
  dest[1] = b;
  dest[0] = a;
  return;
}

int GeraCor(int r, int g, int b)
{
  char  d[8];
  d[7]='\0';
  d[0]= '#';
  GeraHex(r,d+1);
  GeraHex(g,d+3);
  GeraHex(b,d+5);
  return WNamedColor(d);
}

void GeraTabCor(int cor[NUM_ESP][32])
{
  GeraPaleta(cor[0], 255,   0,   0);
  GeraPaleta(cor[1],   0, 255,   0);
  GeraPaleta(cor[2],   0,   0, 255);
  GeraPaleta(cor[3], 255,   0, 255);
  GeraPaleta(cor[4], 191, 255,   0);
  GeraPaleta(cor[5],   0, 255, 255);
  GeraPaleta(cor[6], 255,   0, 127);
  GeraPaleta(cor[7],   0, 159, 255);
  GeraPaleta(cor[8], 191,   0, 255);
  GeraPaleta(cor[9], 159, 255,  63);
  GeraPaleta(cor[10],  0, 191, 255);
  GeraPaleta(cor[11],255, 127,   0);
}

void GeraPaleta (int *cor, int r, int g, int b)
{
  int i;
  for (i=0; i<32; i++)
    cor[i] = GeraCor(r-r*i/64, g-g*i/64, b-b*i/64);
}

void PlotaTabCor ()
{
  int i, j;
  for (i=0; i<12; i++)
    for (j=0; j<32; j++)
      WFillRect(w, j*TAM_JANELA/32, TAM_JANELA  + 3 + i*8, (TAM_JANELA/32)-2, 7, cor[i][j]);
}

void desenha (favo M[N][N])
{
  int i, j, p;
  p = TAM_JANELA/N;
  for (i=0; i<N; i++){
    for (j=0; j<N; j++){
      if (M[i][j].esp != 0){
	int cc;
	cc= 31-2*M[i][j].atp;
	WFillArc(pic, p*j, p*i, 0, 360*64, p, p, 
		 cor[M[i][j].esp-1][cc]);
      }
      else WFillRect(pic, p*j, p*i, 4, 4, Preto);
    }
  }
  PutPic(w, pic, 0, 0, TAM_JANELA, TAM_JANELA, 0, 0);
}


void desenhaplacar(int turno)
{
  /*  Ae, acho que t bom... YUL  */
  int c,i,k, pos[NUM_ESP+1];
  namae na_pop[NUM_ESP+1];
  namae turn;

  for(i=1;i<=NUM_ESP;i++)
    GetNamae(popespecies[i], na_pop[i]);
  GetNamae(turno, turn);

  /*mostra LIDERANA*/
  WFillRect(pla, 0, 0, 150, 700, WNamedColor("gray100"));
  WFillRect(pla, 10, 10, 130, 60, WNamedColor("gray50"));
  WCor(pla,c=WNamedColor("gray100"));
  WPrint(pla,38,23,"NA LIDERANA");
  WCor(pla,c=WNamedColor("gray100"));
  WPrint(pla,30,65,turn);

  k=1;
  for(i=1;i<=NUM_ESP;i++)
    { if(popespecies[i]>popespecies[k]) k=i; }
  for(i=1;i<=NUM_ESP;i++)
    {
      if(k!=i)
	if(popespecies[i]==popespecies[k]) {k=0; break;} /*EMPATE!!*/
    }
  if(k) WCor(pla,c=cor[k-1][0]);
  else  WCor(pla,c=WNamedColor("gray100"));
  WPrint(pla,30,45,especies[k].nome);  /*IMPRIMIMOS A ESP. DA LIDERANA!!*/

  ArrumaRanking (pos);
  /*
  if(!(turno%50))
    {
      for(i=1;i<=NUM_ESP;i++)
	printf("espcie%d: rank%d\n",i,rank[i]);
      getchar();
    }
  */

  for(i=1;i<=NUM_ESP;i++)
    {
      WFillRect(pla, 10, 40 + pos[i]*50, 130, 40, cor[i-1][31]);
      if(popespecies[i]) WCor(pla,c=WNamedColor("gray100"));
      else WCor(pla,c=WNamedColor("gray50"));
      WPrint   (pla, 15, 53 + pos[i]*50 ,especies[i].nome);

      /*Realmente no sei se 2 barras ficou bom...*/
      if(popespecies[i]>=N*N/2)
	{
	  WFillRect(pla, 13, 57 + pos[i]*50, 120, 16, cor[i-1][22]);
	  WFillRect(pla, 15, 60 + pos[i]*50, (240*(popespecies[i]-(N*N)/2))/(N*N), 16, cor[i-1][12]);
	  if(popespecies[i]) WCor(pla,c=WNamedColor("gray100"));
	  else WCor(pla,c=WNamedColor("gray75"));
	  WPrint   (pla, 19, 73 + pos[i]*50 ,na_pop[i]);
	}
      else
	{
	  WFillRect(pla, 13, 57 + pos[i]*50, (240*popespecies[i])/(N*N), 16, cor[i-1][22]);
	  if(popespecies[i])
	    {
	      WCor(pla,c=WNamedColor("gray100"));
	      WPrint   (pla, 19, 73 + pos[i]*50 ,na_pop[i]);
	    }
	  else
	    {
	      WCor(pla,c=WNamedColor("gray75"));
	      WPrint   (pla, 19, 73 + pos[i]*50 ,"extinto");
	    }
	}
    }

  PutPic(placar, pla, 0, 0, 150, 700, 0, 0);
  return;
}

void GetNamae(int num, namae nome)
{
  int k, l;
  /*para o turno*/
  if(num>0)
    {
      for(k=0;;k++)
	if(pow(10,k)<=num && num<pow(10,k+1)) break;
      /*k agora eh o nmero de digitos de num em potencia dez.*/
      
      for(l=0;l<=k;l++)
	nome[l]= (num/(int)pow(10,k-l))%10 + '0';

      nome[k+1]='\0';
    }
  else if(num==0)
    {
      strcpy(nome,"0");
    }
  else if(num<0)
    {
      num*=(-1);
      nome[0]='-';

      for(k=0;;k++)
	if(pow(10,k)<=num && num<pow(10,k+1)) break;
      /*l agora eh o nmero de digitos de num em potencia dez.*/
      
      for(l=0;l<=k;l++)
	nome[l+1]= (num/(int)pow(10,k-l))%10 + '0';

      nome[l+2]='\0';
    }
}

/*rank[k]=rank da especie k*/
void ArrumaRanking (int pos[NUM_ESP+1])
{
  int k, i, j=0;
  int v[NUM_ESP+1];

  for(k=1;k<=NUM_ESP;k++)
    {
      if(!popespecies[k])
	if(rank[k]>=0)
	  {
	    histmorte[k]=iteracoes;
	    j=NUM_ESP;
	    for(i=1;i<=NUM_ESP;i++)
	      if(rank[i]<0) j--;
	    rank[k]=-j;
	  }
      v[k]=popespecies[k];
    } /*isso deixa as espcies extintas com val. negativos, para facilitar*/

  for(k=1;k<=NUM_ESP;k++)
    {
      j=1;
      for(i=1;i<=NUM_ESP;i++)
	{
	  if(v[i]>v[j]) j=i;
	}
      if(v[j]) {if(rank[j]>=0) rank[j]=k;}
      else break;
      v[j]=0;
    }
  for(k=1;k<=NUM_ESP;k++)
    {
      if(rank[k]>=0) pos[k]=rank[k];
      else pos[k]=-rank[k];
    }
  return;
}

void ShowCredits(favo M[N][N])
{
  int invrank[NUM_ESP+1];
  namae na_pop[NUM_ESP+1];
  namae frase;
  PIC p, pic;
  int c;
  int i, j, pk, t=1;

  printf("Crditos\n");
  fin = InitGraph(500, 300, "---BIRA FIGHT--- CRDITOS");
  p   = NewPic(fin, 500, 300);
  /*bkuppic*/
  pic =  NewPic(w, TAM_JANELA, TAM_JANELA);
  WFillRect(pic, 0, 0, TAM_JANELA, TAM_JANELA, WNamedColor("floral white"));
  pk = TAM_JANELA/N;
  for (i=0; i<N; i++){
  for (j=0; j<N; j++){
      if (M[i][j].esp != 0){
	WFillArc(pic, pk*i, pk*j, 0, 360*64, pk, pk, cor[M[i][j].esp-1][31]);
      }
  }}
  /*bkuppic*/

  piccredito(p,pic);
  WFillRect(p, 100, 50, 300,200, WNamedColor("floral white"));
  WCor  (p, c=WNamedColor("orange red"));
  WPrint(p, 180, 100, "BIRAFIGHT -- PETRIPETS");
  WCor  (p, c=WNamedColor("light coral"));
  WPrint(p, 140,  150, "CURSO DE CINCIAS MOLECULARES - TURMA 14");
  WPrint(p, 170, 180, "CCM-0118 COMPUTAO 1");
  WPrint(p, 170, 200, "Prof. Gubi");
  PutPic(fin,p,0,0,500,300,0,0);
  sleep(t);

  piccredito(p,pic);
  WFillRect(p, 60, 50, 380,200, WNamedColor("floral white"));
  WCor  (p, c=WNamedColor("orange red"));
  WPrint(p, 200, 100, "Crditos");
  WCor  (p, c=WNamedColor("light coral"));
  WPrint(p, 90, 130, "Alex        Marina");
  WPrint(p, 90, 145, "Guidoni     Renato");
  WPrint(p, 90, 160, "boo         Ronaldo");
  WPrint(p, 90, 175, "Ana Maria   Srgio");
  WPrint(p, 90, 190, "Ceclia     Tadeu");
  WPrint(p, 90, 205, "Fernanda    Ubiratan");
  WPrint(p, 90, 220, "Larissa     Vitor");
  WPrint(p, 90, 235, "Marcelo     Yul");
  WPrint(p, 90, 250, "Gubi (xwc, orientao, idia, roteiro, etc. etc...)");
  PutPic(fin,p,0,0,500,300,0,0);
  sleep(t);

  piccredito(p,pic);
  WFillRect(p, 150, 125, 200,50, WNamedColor("floral white"));
  WCor  (p, c=WNamedColor("orange red"));
  WPrint(p, 220, 155, "PREMIAO");
  PutPic(fin,p,0,0,500,300,0,0);
  sleep(t);

  for(i=1;i<=NUM_ESP;i++)
    GetNamae(popespecies[i],na_pop[i]);
  rankcredito(invrank);

  for(i=NUM_ESP;i>=1;i--)
    {
      piccredito(p,pic);
      if(i==1) WFillRect(p, 100, 75, 300,150, WNamedColor("gold"));
      else WFillRect(p, 100, 75, 300,150, WNamedColor("floral white"));
      PutPic(fin,p,0,0,500,300,0,0);
      WCor  (fin, c=WNamedColor("orange red"));
      rankfrase(i,frase);
      WPrint(fin, 150, 100, frase);
      usleep(100000);
      WCor  (fin, c=cor[invrank[i]][20]);
      WPrint(fin, 160, 155, especies[invrank[i]].nome);
      usleep(100000);
      WCor  (fin, c=cor[invrank[i]][31]);
      if(popespecies[invrank[i]])
	{
	  strcat(na_pop[invrank[i]], " espcimes sobreviventes");
	  WPrint(fin, 160, 175, na_pop[invrank[i]]);
	}
      else
	{
	  strcpy(frase, "extinta na iteraco ");
	  GetNamae( histmorte[invrank[i]] , na_pop[invrank[i]]);
	  strcat(frase, na_pop[invrank[i]]);
	  WPrint(fin, 160, 175, frase);
	}
      sleep(t);
    }

  printf("Duh!");
  getchar();
  return;
}

void piccredito (PIC pic, PIC fundo)
{
  int x,y;
  x=rand()%(TAM_JANELA-500);
  y=rand()%(TAM_JANELA-300);
  PutPic(pic,fundo,x,y,500,300,0,0);
  return;
}

void rankcredito(int invrank[NUM_ESP+1])
{
  int i,k;
  for(i=1;i<=NUM_ESP;i++)
    if(rank[i]<0) rank[i]*=(-1);
  /*no usaremos mais rank, podemos nos livrar dos valores negativos*/

  for(i=1;i<=NUM_ESP;i++)
    for(k=1;k<=NUM_ESP;k++)
      if(rank[k]==i)
	{
	  invrank[i]=k;
	  break;
	}
  return;
}

void rankfrase(int pos, namae na)
{
  if(pos== 1) strcpy(na,"Primeiro Lugar!");
  if(pos== 2) strcpy(na,"Segundo Lugar!");
  if(pos== 3) strcpy(na,"Terceiro Lugar!");
  if(pos== 4) strcpy(na,"Quarto Lugar!");
  if(pos== 5) strcpy(na,"Quinto Lugar!");
  if(pos== 6) strcpy(na,"Sexto Lugar!");
  if(pos== 7) strcpy(na,"Stimo Lugar!");
  if(pos== 8) strcpy(na,"Oitavo Lugar!");
  if(pos== 9) strcpy(na,"Nono Lugar!");
  if(pos==10) strcpy(na,"Dcimo Lugar!");
  if(pos==11) strcpy(na,"Dcimo Primeiro Lugar!");
  if(pos==12) strcpy(na,"Dcimo Segundo Lugar!");
  return;
}
