/*
Especie criada por:

Renato Mendes Coutinho
Larissa Sadae Kobayashi

*/

#include "funcs.h"
#include "motor.h"
#include <stdlib.h>

#define NN  w[1][2]
#define N2  w[0][2]
#define S   w[3][2]
#define S2  w[4][2]
#define O   w[2][1]
#define O2  w[2][0]
#define E   w[2][3]
#define E2  w[2][4]
#define NO  w[1][1]
#define NO2 w[0][0]
#define NE  w[1][3]
#define NE2 w[0][4]
#define SO  w[3][1]
#define SO2 w[4][0]
#define SE  w[3][3]
#define SE2 w[4][4]
#define NNO w[0][1]
#define NNE w[0][3]
#define ONO w[1][0]
#define ENE w[1][4]
#define SSO w[4][1]
#define SSE w[4][3]
#define OSO w[3][0]
#define ESE w[3][4]

#define NOME Bichinho


#define EU w[2][2]


/* Conta o nmero de amigos (x[1]) e inimigos (x[0]) num raio r ao redor da clula */
static void ContaAA(int r, int x[2], favo[5][5]);

/* Retorna o nmero de atps na direo d em relao ao favo w[i][j] */
static int AtpDir(int i, int j, int d, favo ziv[5][5]);

/* Retorna a espcie na direo d em relao ao favo w[i][j] */
static int EspDir(int i, int j, int d, favo ziv[5][5]);

/* Funs auxiliares q retornam a linha e a coluna de uma clula na direo i em relao  central */
static int PosL(int i);
static int PosC(int i);

/* Funes de jogo! Todas recebem o endereo da inteno e retornam 1 caso a ao deva ser realizada, 0 caso contrrio. O que cada uma faz  auto-explicativo :D */
static int Ocupa(INTENCAO *ts, favo w[5][5]);

static int Ataca(INTENCAO *ts, favo w[5][5]);

static int Ataca3(INTENCAO *ts, favo w[5][5]);

static int Transf(INTENCAO *ts, favo w[5][5]);

static int Transf2(INTENCAO *ts, favo w[5][5]);

static int Transf3(INTENCAO *ts, favo w[5][5]);

static int Transf4(INTENCAO *ts, favo w[5][5]);

/* Faz a atualizao do vetor pblico e tambm no futpub. No retorna nada */
static void AtualizaPUB (INTENCAO *ts, favo w[5][5]);

/* Calcula a distncia de uma clula na posio i,j em relao a outra em x,y */
static int Dist (int i, int j, int x, int y);


/* Vriveis externas */
extern int popespecies[NUM_ESP+1];
extern int gasto[5];
extern int iteracoes;

/* Funo principal! */
INTENCAO baguio2(favo w[5][5])
{
  int i;
  INTENCAO ts;
  ts.acao = FORTALECE;
  ts.param = 0;

  /*Mexendo no PUB*/
  AtualizaPUB(&ts, w);

  /*Ocupacoes - somente se alguma clula ao redor for vazia */
  for (i=0; i<4; i++)
    if (EspDir(2,2,i,w)==0)
      {
	if (Ocupa(&ts, w)) return ts; 
	break; /* No  preciso verificar se h clulas vazias se h pelo menos uma. */
      }

  /* Ataques - apenas com inimigos na vizinhana */
  for (i=0; i<4; i++)
    {
      if (EspDir(2,2,i,w)!=EU.esp && EspDir(2,2,i,w)!=0)
	{
	  if(Ataca3 (&ts, w)) return ts;
	  break;
	}
    }
  
  /*Transferencias*/
  if (iteracoes > -1) /* Usado em algumas verses do programa pra mudana de estratgia ao longo do jogo */
    {if (Transf2(&ts, w)) return ts;}
  else {if (Transf(&ts, w)) return ts;}

  /* Esta gambiarra serve para silenciar os warnings por causa de funes no utilizadas - isso torna possvel trocar facilmente as funes de jogo utilizadas sem se preocupar com isso */
  i=0;
  if(i)
    {Ocupa(&ts,w); Ataca(&ts,w); Ataca3(&ts,w); Transf(&ts,w); Transf2(&ts,w); Transf3(&ts,w); Transf4(&ts,w);}
  
  ts.acao = FORTALECE;
  ts.param = 0;
  return ts;
}

static int Ocupa(INTENCAO *ts, favo w[5][5])
{
  int i, j, l[2]={-1,20}, Aatp[4]={0,0,0,0}, Iatp[4]={0,0,0,0};
  (*ts).acao = OCUP;
  for (i=0; i<4; i++)
    {
      if (EspDir(2,2,i,w)==0)
	{
	  for (j=0; j<4; j++)
	    {
 	      if ((j+2)%4 == i) continue; 
	      if (EspDir (PosL(i), PosC(i),j,w) !=0)
		{
		  if (EspDir (PosL(i), PosC(i),j,w) != EU.esp) 
		    Iatp[i] += AtpDir (PosL(i), PosC(i),j,w);
		  else Aatp[i] += AtpDir (PosL(i), PosC(i),j,w);
		}
	    }
	  if (Iatp[i] < l[1])
	    {
	      l[0] = i;
	      l[1] = Iatp[i];
	      /* l[0] aponta para a direcao com menos inimigos, ou -1 caso nao seja favoravel ocupar, e l[1] diz quantos atps estao por ali */
	    }
	}
    }
  if (l[0]>-1)
    {
      (*ts).dir = l[0];
      (*ts).param = EU.atp-1;
      return 1;
    }
  return 0;
}

static int Ataca(INTENCAO *ts, favo w[5][5])
{
  int i, j, l[2]={-1,40}, Aatp[4]={0,}, Iatp[4]={0,}, z1[2]={0,}, z2[2]={0,};
  ContaAA(1,z1,w);
  ContaAA(2,z2,w);
  (*ts).acao = ATAQUE;
  for (i=0; i<4; i++)
    if (EspDir(2,2,i,w)!=0 && 
	EspDir(2,2,i,w)!=EU.esp &&
	EU.atp > 4)
      {
	for (j=0; j<4; j++)
	  {
	    if ((j+2)%4 == i) continue;
	    if (EspDir (PosL(i), PosC(i),j,w) !=0)
	      {
		if (EspDir (PosL(i), PosC(i),j,w) != EU.esp) 
		  Iatp[i] += AtpDir (PosL(i), PosC(i),j,w);
		else Aatp[i] += AtpDir (PosL(i), PosC(i),j,w);
	      }
	  }
	if (3*AtpDir(2,2,i,w) + Iatp[i] - Aatp[i] < l[1])
	  {
	    l[0] = i;
	    l[1] = 3*AtpDir(2,2,i,w) + Iatp[i] - Aatp[i];
	    /* l[0] aponta para a direcao com mais amigos e menos inimigos, ou -1 caso nao seja favoravel atacar (caso perdido?), e l[1] diz qual o saldo de atps por ali */
	  }
      }
  if (l[0]>-1)
    {
      ts->dir = l[0];
      ts->param =  EU.atp - AtpDir(2,2,l[0],w) > 2 ? AtpDir(2,2,l[0],w) + 1 : EU.atp - 1 - gasto[ATAQUE];
      if (EU.atp - AtpDir(2,2,l[0],w) < 2) return 0;
      if (EspDir(2,2,(l[0]+2)%4,w) == EU.esp &&
	  AtpDir(2,2,(l[0]+2)%4,w) > 5) return 1;
      return 1;
    }
  return 0;
}

static int Ataca3(INTENCAO *ts, favo w[5][5])
{
  int i, j, l[2]={-1,50}, Aatp[4]={0,}, Iatp[4]={0,}, z1[2]={0,};
  ContaAA(1,z1,w);
  (*ts).acao = ATAQUE;
  if (EU.atp < 5) return 0;
  for (i=0; i<4; i++)
    if (EspDir(2,2,i,w)!=0 && 
	EspDir(2,2,i,w)!=EU.esp)
      {
	for (j=0; j<4; j++)
	  {
	    if ((j+2)%4 == i) continue;
	    if (EspDir (PosL(i), PosC(i),j,w) !=0)
	      {
		if (EspDir (PosL(i), PosC(i),j,w) != EU.esp) 
		  Iatp[i] += AtpDir (PosL(i), PosC(i),j,w);
		else Aatp[i] += AtpDir (PosL(i), PosC(i),j,w);
	      }
	  }
	if (AtpDir(2,2,i,w) + Iatp[i] - Aatp[i] < l[1])
	  {
	    l[0] = i;
	    l[1] = AtpDir(2,2,i,w) + Iatp[i] - Aatp[i];
	    /* l[0] aponta para a direcao com mais amigos e menos inimigos, ou -1 caso nao seja favoravel atacar (caso perdido?), e l[1] diz qual o saldo de atps por ali */
	  }
      }
  if (l[0]>-1)
    {
      (*ts).dir = l[0];
      (*ts).param =  EU.atp - AtpDir(2,2,l[0],w) - gasto[ATAQUE] > 0 ? AtpDir(2,2,l[0],w) : EU.atp - 1 - gasto[ATAQUE];
      if (EspDir(2,2,(l[0]+2)%4,w) == EU.esp &&
	  AtpDir(2,2,(l[0]+2)%4,w) > 8) return 1;
      if (EU.atp - Iatp[l[0]] < -10) return 0;
      return 1;
    }
  return 0;
}


static int Transf(INTENCAO *ts, favo w[5][5])
{
  int i, j, d,/*  k[4], */ l[2]={0,}, z1[2]={0,}, z2[2]={0,}/* , Iatp[4]={0,}, Aatp[4]={0,} */;
  ContaAA(1,z1,w);
  ContaAA(2,z2,w);
  ts->acao = TRANSF;

  for (i=0; i<4; i++)
    if (EspDir(2,2,i,w)!=EU.esp)
      return 0;


  /* Este pedao foi comentado porque essa funo passou a ser auxiliar  funo principal de transferncia, a Transf2, q j continha os mesmos comandos */

/*   if (z1[0]>0) /\*Gente muito, muito prxima*\/ */
/*     { */
/*       l[0] = -1; */
/*       l[1] = -15; */
/*       for (i=0; i<4; i++) /\* Olha pra cada direo da clula*\/ */
/* 	{ */
/* 	  for (j=0; j<4; j++) /\* Olha pros arredores de cada clula vizinha*\/ */
/* 	    { */
/* 	      if ((j+2)%4 == i) continue; /\* Evita olhar de volta pra clula do meio *\/ */
/* 	      if (EspDir (PosL(i), PosC(i),j,w) != 0) */
/* 		{ */
/* 		  if (EspDir (PosL(i), PosC(i),j,w) != EU.esp)  */
/* 		    Iatp[i] += AtpDir (PosL(i), PosC(i),j,w); */
/* 		  else Aatp[i] += AtpDir (PosL(i), PosC(i),j,w); */
/* 		} */
/* 	    } */
/* 	  if (Iatp[i] - Aatp[i] > l[1]) */
/* 	    { */
/* 	      l[0] = i; */
/* 	      l[1] = Iatp[i] - Aatp[i]; */
/* 	      /\* l[0] aponta para a direcao com mais amigos e menos inimigos, ou -1 caso nao seja favoravel transferir, e l[1] diz qual o saldo de atps por ali *\/ */
/* 	    } */
/* 	} */
/*       if (l[0]>-1) */
/* 	{ */
/* 	  (*ts).dir = l[0]; */
/* 	  (*ts).param = EU.atp - 1; */
/* 	  return 1; */
/* 	} */
/*       else return 0; */
/*     } */


/*   if (z2[0]>0) /\*Gente mais ou menos prxima*\/ */
/*     { */
/*       for (i=0; i<4; i++) */
/* 	k[i]=0; */
/*       l[0]=-1; */
/*       l[1]=0; */
/*       for (i=0; i<5; i++) */
/* 	for (j=0; j<5; j++) */
/* 	  { */
/* 	    if (w[i][j].esp==EU.esp || w[i][j].esp==0) */
/* 	      continue; */
/* 	    if (i<2) k[0] += w[i][j].atp; */
/* 	    if (i>2) k[2] += w[i][j].atp; */
/* 	    if (j<2) k[3] += w[i][j].atp; */
/* 	    if (j>2) k[1] += w[i][j].atp; */
/* 	  } */
/*       for (i=0; i<4; i++) */
/* 	if (k[i]>l[1]) */
/* 	  { */
/* 	    l[1] = k[i]; */
/* 	    l[0] = i; */
/* 	  } */
/*       if (l[0]>-1) */
/* 	{ */
/* 	  (*ts).dir = l[0]; */
/* 	  (*ts).param = EU.atp-1; */
/* 	  return 1; */
/* 	} */
/*       return 0; */
/*     } */

/*   if (z2[1]<25) /\* Borda vazia *\/ */
/*     { */
/*       l[0] = -1; */
/*       l[1] = 0; */
/*       for (i=0; i<4; i++) */
/* 	k[i] = 0; */
/*       for (i=0; i<5; i++) */
/* 	for (j=0; j<5; j++) */
/* 	  { */
/* 	    if (w[i][j].esp == 0) */
/* 	      { */
/* 		if (i<2) k[0]++; */
/* 		if (i>2) k[2]++; */
/* 		if (j<2) k[3]++; */
/* 		if (j>2) k[1]++; */
/* 	      } */
/* 	  } */
/*       for (i=0; i<4; i++) */
/* 	if (k[i]>l[1]) */
/* 	  { */
/* 	    l[1] = k[i]; */
/* 	    l[0] = i; */
/* 	  } */
/*       if (l[0]>-1) */
/* 	{ */
/* 	  ts->dir = l[0]; */
/* 	  ts->param = EU.atp - 1 - gasto[TRANSF]; */
/* 	  return 1; */
/* 	} */
/*       return 0; */
/*     } */

  if (z2[1]==25) 
    {
      d=0;
      l[0] = -1;
      l[1] = -1;
      for (i=0; i<5; i++)
	for (j=0; j<5; j++)
	  {
	    if (i==2 && j==2) continue;
	    if (w[i][j].pub[1] - Dist(2,2,i,j) > d)
	      {
		d = w[i][j].pub[1] - Dist(2,2,i,j);
		l[0] = i;
		l[1] = j;
	      }
	  }
      if (l[0] >-1 && l[1]>-1)
	{
	  switch(l[0])
	    {
	    case 4: {ts->dir = 2; break;}
	    case 0: {ts->dir = 0; break;}
	    default: switch (l[1])
	      {
	      case 4: {ts->dir = 1; break;}
	      case 0: {ts->dir = 3; break;}
	      }
	    }
	      ts->param = EU.atp - 1;
	      return 1;
	    }
	  return 0;
	}
      return 0;
}

static int Transf2(INTENCAO *ts, favo w[5][5])
{
  int i, j, k[4], l[2]={0,}, z1[2]={0,}, z2[2]={0,}, Iatp[4]={0,}, Aatp[4]={0,};
  ContaAA(1,z1,w);
  ContaAA(2,z2,w);
  ts->acao = TRANSF;

  for (i=0; i<4; i++)
    if (EspDir(2,2,i,w)!=EU.esp)
      return 0;

  if (z1[0]>0) /*Gente muito, muito prxima*/
    {
      l[0] = -1;
      l[1] = -15;
      for (i=0; i<4; i++) /* Olha pra cada direo da clula*/
	{
	  for (j=0; j<4; j++) /* Olha pros arredores de cada clula vizinha*/
	    {
	      if ((j+2)%4 == i) continue; /* Evita olhar de volta pra clula do meio */
	      if (EspDir (PosL(i), PosC(i),j,w) != 0)
		{
		  if (EspDir (PosL(i), PosC(i),j,w) != EU.esp) 
		    Iatp[i] += AtpDir (PosL(i), PosC(i),j,w);
		  else Aatp[i] += AtpDir (PosL(i), PosC(i),j,w);
		}
	    }
	  if (Iatp[i] - Aatp[i] > l[1])
	    {
	      l[0] = i;
	      l[1] = Iatp[i] - Aatp[i];
	      /* l[0] aponta para a direcao com mais amigos e menos inimigos, ou -1 caso nao seja favoravel transferir, e l[1] diz qual o saldo de atps por ali */
	    }
	}
      if (l[0]>-1)
	{
	  ts->dir = l[0];
	  ts->param = EU.atp - 1;
	  return 1;
	}
      else return 0;
    }

  if (z2[0]>0) /*Gente mais ou menos prxima*/
    {
      for (i=0; i<4; i++)
	k[i]=0;
      l[0]=-1;
      l[1]=0;
      for (i=0; i<5; i++)
	for (j=0; j<5; j++)
	  {
	    if (w[i][j].esp==EU.esp || w[i][j].esp==0)
	      continue;
	    if (i<2) k[0] += w[i][j].atp;
	    if (i>2) k[2] += w[i][j].atp;
	    if (j<2) k[3] += w[i][j].atp;
	    if (j>2) k[1] += w[i][j].atp;
	  }
      for (i=0; i<4; i++)
	if (k[i]>l[1])
	  {
	    l[1] = k[i];
	    l[0] = i;
	  }
      if (l[0]>-1)
	{
	  (*ts).dir = l[0];
	  (*ts).param = EU.atp-1;
	  return 1;
	}
      return 0;
    }

  if (z2[1]<25) /* Borda vazia */
    {
      l[0] = -1;
      l[1] = 0;
      for (i=0; i<4; i++)
	k[i] = 0;
      for (i=0; i<5; i++)
	for (j=0; j<5; j++)
	  {
	    if (w[i][j].esp == 0)
	      {
		if (i<2) k[0]++;
		if (i>2) k[2]++;
		if (j<2) k[3]++;
		if (j>2) k[1]++;
	      }
	  }
      for (i=0; i<4; i++)
	if (k[i]>l[1])
	  {
	    l[1] = k[i];
	    l[0] = i;
	  }
      if (l[0]>-1)
	{
	  ts->dir = l[0];
	  ts->param = EU.atp - 1 - gasto[TRANSF];
	  return 1;
	}
      return 0;
    }

  if (z2[1]==25) /* Eh aqui q ELES entram! */
    { 
      k[0] = 200;
      k[1] = -1;
      k[2] = -1;
      k[3] = 5;
      l[0]=-1; 
      l[1]=-1;
      for (i=0; i<5; i++) 
 	for (j=0; j<5; j++) 
 	  { 
   	    if ((i==j)||(i==4-j)) continue;  
	    if ((w[i][j].pub[3]%10 > 0) && (w[i][j].pub[3]/10 + Dist(2,2,i,j) < k[0]))
	      {
		k[0] = w[i][j].pub[3]/10 + Dist(2,2,i,j);
		k[1] = i;
		k[2] = j;
	      }
 	  } 

      /* Vamos usar a arma secreta - chama a funo Transf para distncias curtas!*/
      if (k[0]<5) 
	{
	  if (Transf(ts, w)) return 1;
	  else return 0;
	}

      /* temos uma celula-alvo */
      if (k[1]>0 && k[2]>-1)
 	{ 
	  for (i=0; i<5; i+=2)
	    for (j=0; j<5; j+=2)
	      if ((j!=2 || i!=2) && ((j+i)%4==2) && (Dist (k[1],k[2],i,j)<k[3]))
		{
		  k[3] = Dist (k[1],k[2],i,j);
		  l[0] = i;
		  l[1] = j;
		}
	  switch(l[0])
	    {
	    case 0: {ts->dir = 0; break;}
	    case 4: {ts->dir = 2; break;}
	    case 2: switch (l[1])
	      {
	      case 0: {ts->dir = 3; break;}
	      case 4: {ts->dir = 1; break;}
	      case 2: return 0;
	      }
	    default: return 0;
	    }
 	  ts->param = EU.atp - 1; 
 	  return 1; 
	} 
    } 
  return 0;
}


static int Transf3(INTENCAO *ts, favo w[5][5])
{
  int i, j, k[4], l[2]={0,}, z1[2]={0,}, z2[2]={0,}, Iatp[4]={0,}, Aatp[4]={0,};
  ContaAA(1,z1,w);
  ContaAA(2,z2,w);
  ts->acao = TRANSF;

  for (i=0; i<4; i++)
    if (EspDir(2,2,i,w)!=EU.esp)
      return 0;

  if (z1[0]>0) /*Gente muito, muito prxima*/
    {
      l[0] = -1;
      l[1] = -15;
      for (i=0; i<4; i++) /* Olha pra cada direo da clula*/
	{
	  for (j=0; j<4; j++) /* Olha pros arredores de cada clula vizinha*/
	    {
	      if ((j+2)%4 == i) continue; /* Evita olhar de volta pra clula do meio */
	      if (EspDir (PosL(i), PosC(i),j,w) != 0)
		{
		  if (EspDir (PosL(i), PosC(i),j,w) != EU.esp) 
		    Iatp[i] += AtpDir (PosL(i), PosC(i),j,w);
		  else Aatp[i] += AtpDir (PosL(i), PosC(i),j,w);
		}
	    }
	  if (Iatp[i] - Aatp[i] > l[1])
	    {
	      l[0] = i;
	      l[1] = Iatp[i] - Aatp[i];
	      /* l[0] aponta para a direcao com mais amigos e menos inimigos, ou -1 caso nao seja favoravel transferir, e l[1] diz qual o saldo de atps por ali */
	    }
	}
      if (l[0]>-1)
	{
	  (*ts).dir = l[0];
	  (*ts).param = EU.atp - 1;
	  return 1;
	}
      else return 0;
    }


  if (z2[0]>0) /*Gente mais ou menos prxima*/
    {
      for (i=0; i<4; i++)
	k[i]=0;
      l[0]=-1;
      l[1]=0;
      for (i=0; i<5; i++)
	for (j=0; j<5; j++)
	  {
	    if (w[i][j].esp==EU.esp || w[i][j].esp==0)
	      continue;
	    if (i<2) k[0] += w[i][j].atp;
	    if (i>2) k[2] += w[i][j].atp;
	    if (j<2) k[3] += w[i][j].atp;
	    if (j>2) k[1] += w[i][j].atp;
	  }
      for (i=0; i<4; i++)
	if (k[i]>l[1])
	  {
	    l[1] = k[i];
	    l[0] = i;
	  }
      if (l[0]>-1)
	{
	  (*ts).dir = l[0];
	  (*ts).param = EU.atp-1;
	  return 1;
	}
      return 0;
    }

  if (z2[1]<25) /* Borda vazia */
    {
      l[0] = -1;
      l[1] = 0;
      for (i=0; i<4; i++)
	k[i] = 0;
      for (i=0; i<5; i++)
	for (j=0; j<5; j++)
	  {
	    if (w[i][j].esp == 0)
	      {
		if (i<2) k[0]++;
		if (i>2) k[2]++;
		if (j<2) k[3]++;
		if (j>2) k[1]++;
	      }
	  }
      for (i=0; i<4; i++)
	if (k[i]>l[1])
	  {
	    l[1] = k[i];
	    l[0] = i;
	  }
      if (l[0]>-1)
	{
	  ts->dir = l[0];
	  ts->param = EU.atp - 1 - gasto[TRANSF];
	  return 1;
	}
      return 0;
    }

  if (z2[1]==25) 
    { 
      for (i=0; i<4; i++) 
 	k[i]=0; 
      l[0]=-1; 
      l[1]=3000; 
      for (i=0; i<5; i++) 
 	for (j=0; j<5; j++) 
 	  { 
 	    if (i==2 && j==2) continue; 
 	    if (i<2) k[0] += w[i][j].pub[4]/10; 
 	    if (i>2) k[2] += w[i][j].pub[4]/10; 
 	    if (j<2) k[3] += w[i][j].pub[4]/10; 
 	    if (j>2) k[1] += w[i][j].pub[4]/10; 
 	  } 
      for (i=0; i<4; i++) 
 	if (k[i]<l[1]) 
 	  { 
 	    l[1] = k[i]; 
 	    l[0] = i; 
 	  } 
      if (l[0]>-1) 
 	{ 
 	  ts->dir = l[0]; 
 	  ts->param = EU.atp - 1; 
 	  return 1; 
 	} 
    } 
  return 0;
}

static int Transf4(INTENCAO *ts, favo w[5][5])
{
  int i, j, k[4], l[2]={0,}, z1[2]={0,}, z2[2]={0,}, Iatp[4]={0,}, Aatp[4]={0,};
  ContaAA(1,z1,w);
  ContaAA(2,z2,w);
  ts->acao = TRANSF;

  for (i=0; i<4; i++)
    if (EspDir(2,2,i,w)!=EU.esp)
      return 0;

  if (z1[0]>0) /*Gente muito, muito prxima*/
    {
      l[0] = -1;
      l[1] = -15;
      for (i=0; i<4; i++) /* Olha pra cada direo da clula*/
	{
	  for (j=0; j<4; j++) /* Olha pros arredores de cada clula vizinha*/
	    {
	      if ((j+2)%4 == i) continue; /* Evita olhar de volta pra clula do meio */
	      if (EspDir (PosL(i), PosC(i),j,w) != 0)
		{
		  if (EspDir (PosL(i), PosC(i),j,w) != EU.esp) 
		    Iatp[i] += AtpDir (PosL(i), PosC(i),j,w);
		  else Aatp[i] += AtpDir (PosL(i), PosC(i),j,w);
		}
	    }
	  if (Iatp[i] - Aatp[i] > l[1])
	    {
	      l[0] = i;
	      l[1] = Iatp[i] - Aatp[i];
	      /* l[0] aponta para a direcao com mais amigos e menos inimigos, ou -1 caso nao seja favoravel transferir, e l[1] diz qual o saldo de atps por ali */
	    }
	}
      if (l[0]>-1)
	{
	  (*ts).dir = l[0];
	  (*ts).param = EU.atp - 1;
	  return 1;
	}
      else return 0;
    }


  if (z2[0]>0) /*Gente mais ou menos prxima*/
    {
      for (i=0; i<4; i++)
	k[i]=0;
      l[0]=-1;
      l[1]=0;
      for (i=0; i<5; i++)
	for (j=0; j<5; j++)
	  {
	    if (w[i][j].esp==EU.esp || w[i][j].esp==0)
	      continue;
	    if (i<2) k[0] += w[i][j].atp;
	    if (i>2) k[2] += w[i][j].atp;
	    if (j<2) k[3] += w[i][j].atp;
	    if (j>2) k[1] += w[i][j].atp;
	  }
      for (i=0; i<4; i++)
	if (k[i]>l[1])
	  {
	    l[1] = k[i];
	    l[0] = i;
	  }
      if (l[0]>-1)
	{
	  (*ts).dir = l[0];
	  (*ts).param = EU.atp-1;
	  return 1;
	}
      return 0;
    }

  if (z2[1]<25) /* Borda vazia */
    {
      l[0] = -1;
      l[1] = 0;
      for (i=0; i<4; i++)
	k[i] = 0;
      for (i=0; i<5; i++)
	for (j=0; j<5; j++)
	  {
	    if (w[i][j].esp == 0)
	      {
		if (i<2) k[0]++;
		if (i>2) k[2]++;
		if (j<2) k[3]++;
		if (j>2) k[1]++;
	      }
	  }
      for (i=0; i<4; i++)
	if (k[i]>l[1])
	  {
	    l[1] = k[i];
	    l[0] = i;
	  }
      if (l[0]>-1)
	{
	  ts->dir = l[0];
	  ts->param = EU.atp - 1 - gasto[TRANSF];
	  return 1;
	}
      return 0;
    }

  if (z2[1]==25) 
    { 
      l[0] = -1;
      l[1] = 200;
      for (i=0; i<5; i+=2)
	for (j=0; j<5; j+=2)
	  {
	    if ((i==j)||(i==4-j)) continue;
	    if (w[i][j].pub[3]%10>0 && w[i][j].pub[3]/10 < l[1])
	      {
		l[1] = w[i][j].pub[3];
		if (i==2) l[0] = 1 + j/2;
		else if (j==2) l[0] = i/2;
	      }
	  }
      if (l[0]>-1)
	{
	  ts->dir = l[0];
	  ts->param = EU.atp - 1;
	  return 1;
	}
      return 0;
    }
  return 0;
}

static void ContaAA(int r, int x[2], favo w[5][5])
{
  int i, j;
  for (i=2-r; i<=2+r; i++)
    for (j=2-r; j<=2+r; j++)
      {
	if(w[i][j].esp != 0 && w[i][j].esp != EU.esp) x[0]++; /*Inimigos*/
	if(w[i][j].esp == EU.esp) x[1]++; /*Amigos*/
      }
}

static int AtpDir(int i, int j, int d, favo w[5][5]) {
  switch (d) {
  case NORTE: {if (i-1 >= 0) return w[i-1][j].atp; else return 0;}
  case SUL:   {if (i+1 <= 4) return w[i+1][j].atp; else return 0;}
  case OESTE: {if (j-1 >= 0) return w[i][j-1].atp; else return 0;}
  case LESTE: {if (j+1 <= 4) return w[i][j+1].atp; else return 0;}
  default: return 0;
  }
}

static int EspDir(int i, int j, int d, favo w[5][5]) {
  switch (d) {
  case NORTE: {if (i-1 >= 0) return w[i-1][j].esp; else return 0;}
  case SUL:   {if (i+1 <= 4) return w[i+1][j].esp; else return 0;}
  case OESTE: {if (j-1 >= 0) return w[i][j-1].esp; else return 0;}
  case LESTE: {if (j+1 <= 4) return w[i][j+1].esp; else return 0;}
  default: return 0;
  }
}

static int PosL(int i)
{
  switch(i)
    {
    case 0: return 1;
    case 2: return 3;
    default: return 2;
    }
}

static int PosC(int i)
{
  switch(i)
    {
    case 1: return 3;
    case 3: return 1;
    default: return 2;
    }
}


static void AtualizaPUB (INTENCAO *ts, favo w[5][5])
{
  int i, j, d=200, z1[2]={0,}, z2[2]={0,};

  for (i=0; i<TAM_PUB-1; i++)
    (*ts).pub[i] = EU.pub[i];
  (*ts).pub[3] = 0;

  for (i=1; i<TAM_PUB; i++)
    (*ts).futpub[i] = 0;
  (*ts).futpub[0] = ts->futpub[1]  = iteracoes; /* Coloca no pub[0] a "data de nascimento" da clula */

  ContaAA(1,z1,w);
  ContaAA(2,z2,w);

  /* Propaga pelo pub[1] um valor q inclui a data de nascimento de alguma clula da borda menos a distncia at ela - uma forma de procurar os lugares para onde a espcie cresce*/
  d=0;
  for (i=0; i<5; i++)
    for (j=0; j<5; j++)
      {
	if (i==2 && j==2) continue;
	if (w[i][j].esp == EU.esp && w[i][j].pub[1] - Dist(2,2,i,j) > d)
	  d = w[i][j].pub[1] - Dist(2,2,i,j);
      }
  if (d)
    ts->pub[1] = w[i][j].pub[1] - Dist(2,2,i,j);
  
  
  if (z2[0]==0 && z2[1]<25) /* Detecta bordas livres */
    {
      d=200;
      for (i=0; i<5; i++)
	for (j=0; j<5; j++)
	  {
	    if (i==2 && j==2) continue;
	    if (w[i][j].esp == 0 && Dist (2,2,i,j) < d)
	      d = Dist (2,2,i,j);
	  }
      ts->pub[3] = 10*d + 2;
    }

  if (z2[0] != 0) /* Detecta conflitos */
    {
      d=200;
      for (i=0; i<5; i++)
	for (j=0; j<5; j++)
	  {
	    if (i==2 && j==2) continue;
	    if (w[i][j].esp != 0 && w[i][j].esp != EU.esp && Dist (2,2,i,j) < d)
	      d = Dist (2,2,i,j);
	  }
      ts->pub[3] = 10*d + 3;
    }
  
  if (z2[1]==25) /* No meio da galera */
    {
      d=200;
      if (EU.pub[3]%10 > 1)
	{
	  ts->pub[3] = -1;
	  return;
	}

      for (i=0; i<5; i++)
	for (j=0; j<5; j++)
	  {
	    if (i==2 && j==2) continue;
	    if (w[i][j].pub[3]%10 !=0 && (w[i][j].pub[3]/10 + Dist(2,2,i,j)) < d)
	      d = w[i][j].pub[3]/10 + Dist(2,2,i,j);
	  }
      ts->pub[3] = 10*d + 1;
      if (d<2) ts->pub[3]=0;
    }
  
  /* cdigo do 1o dgito do vetor pblico na posio 3 (pub[3]%10)
-1 - era isso, mas nao sei mais! 
0 - nada?
1 - tem algo em algum lugar
2 - borda vazia
3 - gente perto

pub[3]/10  a distncia dessa clula  borda
  */
  return;
}

static int Dist (int i, int j, int x, int y)
{
  return abs(i-x) + abs(j-y);
}
