/*
Especie criada por:

Lucas Furukawa Gadani

*/


#include "funcs.h"
#include "motor.h"
#include <stdlib.h>
#include <limits.h>
#define NOME nem to tosco v5

INTENCAO tosco5 (favo f[5][5]);
extern int gasto[5];
extern int iteracoes;

/* funo de ocupao - retorna zero se no ocupa, 1 se ocupa */
static int ocupa(favo f[5][5], INTENCAO *ret);

/* funo de ataque - retorna zero se no ataca, 1 se ataca */
static int ataca(favo f[5][5], INTENCAO *ret);

/* funo de transferncias - retorna zero se transfere, 1, c.c. */
static int transfere(favo f[5][5], INTENCAO *ret);

union dists {
   int i;
   unsigned u;
   struct pos {
      unsigned n : 8;
      unsigned l : 8;
      unsigned s : 8;
      unsigned o : 8;
   } p;
};

static void verifica_dists(union dists *d) {
   if(d->p.n > 1<<7)
      d->p.n = 1<<7;
   if(d->p.l > 1<<7)
      d->p.l = 1<<7;
   if(d->p.s > 1<<7)
      d->p.s = 1<<7;
   if(d->p.o > 1<<7)
      d->p.o = 1<<7;
}

/* funo de ocupao */
static int ocupa(favo f[5][5], INTENCAO *ret) {
   unsigned podeocupar = 0;
   int r;

   /* ocupa se tiver vazio */
   if(f[1][2].esp == 0) /* NORTE */
      podeocupar |= 1;
   if(f[2][3].esp == 0) /* LESTE */
      podeocupar |= 1<<1;
   if(f[3][2].esp == 0) /* SUL */
      podeocupar |= 1<<2;
   if(f[2][1].esp == 0) /* OESTE */
      podeocupar |= 1<<3;

   if(podeocupar) {
      do {
	 r = rand();
      } while(!(podeocupar & (1<<(r%4))));

      if(r%4 == 0)
	 ret->dir = NORTE;
      else if(r%4 == 1)
	 ret->dir = LESTE;
      else if(r%4 == 2)
	 ret->dir = SUL;
      else
	 ret->dir = OESTE;

      ret->acao = OCUP;
      ret->param = f[2][2].atp/2;
      ret->pub[0] = 1;
      ret->futpub[0] = 0;

      if(f[2][2].esp == f[2][1].esp
	 && f[2][2].esp == f[1][2].esp
	 && f[2][2].esp == f[3][2].esp
	 && f[2][2].esp == f[2][3].esp)
	 ret->param = f[2][2].atp - 1;

      return 1;
   }

   return 0;
}

/* funo de ataque */
static int ataca(favo f[5][5], INTENCAO *ret) {
   int min;

   /* veja os vizinhos, se puder atacar, destrua */
   /* tem q ter no mnimo 1 pra ficar, gasto[ATAQUE] e mais 1 pra atacar */
   if(f[2][2].atp > 1 + gasto[ATAQUE]) {

      /* procura o mais fraco */
      min = MAX_ATP+1;
      ret->acao = FORTALECE;

      if(f[1][2].atp && f[1][2].esp != f[2][2].esp) { /* norte */
	 min = f[1][2].atp;
	 ret->dir=NORTE; 
	 ret->acao=ATAQUE; 
      }
      if(f[2][3].atp && f[2][3].esp != f[2][2].esp && min > f[2][3].atp) { /* leste */
	 min = f[2][3].atp;
	 ret->dir=LESTE; 
	 ret->acao=ATAQUE; 
      }
      if(f[3][2].atp && f[3][2].esp != f[2][2].esp && min > f[3][2].atp) { /* sul */
	 min = f[3][2].atp;
	 ret->dir=SUL; 
	 ret->acao=ATAQUE; 
      }
      if(f[2][1].atp && f[2][1].esp != f[2][2].esp && min > f[2][1].atp) { /* oeste */
	 min = f[2][1].atp;
	 ret->dir=OESTE; 
	 ret->acao=ATAQUE; 
      }

      if(ret->acao == ATAQUE) {
	 /* se posso matar, mato */
	 if(min + gasto[ATAQUE] + 1 < f[2][2].atp) {
	    ret->param = min + 1;
	    return 1;
	 }

	 /* no posso matar, tento atacar com o mximo que posso */
	 ret->param = f[2][2].atp - gasto[ATAQUE] - 1;

	 /* obviamente no vale a pena gastar atp pra atacar e atacar
	  * com um valor na mesma ordem de grandeza. mas pra descobrir]
	  * o quanto vale a pena  muito difcil, s com heurstica */
	 /* est calibrado para gasto[ATAQUE] == 1 */
	 if(iteracoes < 30 && ret->param > 2*gasto[ATAQUE] + 1)
	    return 1;
	 if(ret->param > 4*gasto[ATAQUE] + 1)
	    return 1;
      }
   }

   return 0;
}

/* funo de transferncia */
static int transfere(favo f[5][5], INTENCAO *ret) {
   int min;
   union dists d, o;

   ret->acao = FORTALECE;

   /* inicializo os vetores pblicos */
   /* pub[0] = distncias at as bordas, N, S, L, O */
   /* funciona assim:
    * primeiros 8 bits: dist. norte
    * prximos 8 bits: dist. leste
    * prximos 8 bits: dist. sul
    * ltimos 8 bits: dist. oeste */
   ret->futpub[0] = 0;
   ret->pub[0] = 0;
   d.u = 0;

   /* tenho um inimigo! nem pense em transferir! */
   o.i = f[1][2].pub[0];
   if(f[2][2].esp != f[1][2].esp) /* norte */
      d.p.n = 1;
   else {
      if(o.p.n == 0)
	 d.p.n = 1 << 7;
      else
	 d.p.n = o.p.n + 1;
   }
   o.i = f[2][3].pub[0];
   if(f[2][2].esp != f[2][3].esp) /* leste */
      d.p.l = 1;
   else {
      if(o.p.l == 0)
	 d.p.l = 1 << 7;
      else
	 d.p.l = o.p.l + 1;
   }
   o.i = f[3][2].pub[0];
   if(f[2][2].esp != f[3][2].esp) /* sul */
      d.p.s = 1;
   else {
      if(o.p.s == 0)
	 d.p.s = 1 << 7;
      else
	 d.p.s = o.p.s + 1;
   }
   o.i = f[2][1].pub[0];
   if(f[2][2].esp != f[2][1].esp) /* oeste */
      d.p.o = 1;
   else {
      if(o.p.o == 0)
	 d.p.o = 1 << 7;
      else
	 d.p.o = o.p.o + 1;
   }

   if(d.p.n == 1
      || d.p.l == 1
      || d.p.s == 1
      || d.p.o == 1) {

      verifica_dists(&d);
      ret->pub[0] = d.i;
      return 0;
   }

   /* no tenho inimigo. TRANSFIRA! */

   /* veja se algum vizinho tem um inimigo */
   min = MAX_ATP+1;
   if(f[2][2].esp != f[0][2].esp
      || f[2][2].esp != f[1][1].esp
      || f[2][2].esp != f[1][3].esp) { /* norte */
      min = f[1][2].atp;
      ret->dir = NORTE;
      ret->acao = TRANSF;
      d.p.n = 2;
   } else {
      o.i = f[0][2].pub[0];
      d.p.n = o.p.n + 2;
   }
   if((f[2][2].esp != f[1][3].esp
      || f[2][2].esp != f[2][4].esp
      || f[2][2].esp != f[3][3].esp)) { /* leste */

      if(min > f[2][3].atp) {
	 min = f[2][3].atp;
	 ret->dir = LESTE;
	 ret->acao = TRANSF;
      }
      d.p.l = 2;
   } else {
      o.i = f[2][4].pub[0];
      d.p.l = o.p.l + 2;
   }
   if((f[2][2].esp != f[3][1].esp
      || f[2][2].esp != f[4][2].esp
      || f[2][2].esp != f[3][3].esp)) { /* sul */

      if(min > f[3][2].atp) {
	 min = f[3][2].atp;
	 ret->dir = SUL;
	 ret->acao = TRANSF;
      }
      d.p.s = 2;
   } else {
      o.i = f[4][2].pub[0];
      d.p.s = o.p.s + 2;
   }
   if((f[2][2].esp != f[1][1].esp
      || f[2][2].esp != f[2][0].esp
      || f[2][2].esp != f[3][1].esp)) { /* oeste */

      if(min > f[2][1].atp) {
	 min = f[2][1].atp;
	 ret->dir = OESTE;
	 ret->acao = TRANSF;
      }
      d.p.o = 2;
   } else {
      o.i = f[2][0].pub[0];
      d.p.o = o.p.o + 2;
   }

   /* meu vizinho tem um INIMIGO! AJUDE-O */
   if(ret->acao == TRANSF) {
      ret->param = f[2][2].atp - 1; /* transfira tudo */
      verifica_dists(&d);
      ret->pub[0] = d.i;

      return 1;
   }

   /* ok, meus vizinhos no tem inimigos */

   /* veja a distncia da fronteira */
   /* norte */
   o.i = f[0][2].pub[0];
   min = o.p.n;
   d.p.n = o.p.n + 2;
   ret->acao = TRANSF;
   ret->dir = NORTE;

   /* leste */
   o.i = f[2][4].pub[0];
   d.p.l = o.p.l + 2;
   if(min > o.p.l) {
      min = o.p.l;
      ret->dir=LESTE; 
   }

   /* sul */
   o.i = f[4][2].pub[0];
   d.p.s = o.p.s + 2;
   if(min > o.p.s) {
      min = o.p.s;
      ret->dir=SUL;
   }

   /* oeste */
   o.i = f[2][0].pub[0];
   d.p.o = o.p.o + 2;
   if(min > o.p.o) {
      min = o.p.o;
      ret->dir=OESTE; 
   }

   ret->param = f[2][2].atp - 1;
   verifica_dists(&d);
   ret->pub[0] = d.i;

   return 1;
}

INTENCAO tosco5 (favo f[5][5]) {
   INTENCAO ret;

   /* devo ocupar? */
   if(ocupa(f, &ret))
      return ret;

   /* no posso ocupar, posso atacar? */
   if(ataca(f, &ret))
      return ret;

   /* no posso atacar nem ocupar. vou transferir! */
   if(transfere(f, &ret))
      return ret;

   ret.acao = FORTALECE;
   ret.param = 0;
   return ret;
}
